#ifndef _MIR_SP_CONTROLSWIDGET_H_
#define _MIR_SP_CONTROLSWIDGET_H_
/*
 * Copyright (c) 2011,
 * Technical University Of Gdansk,
 * Faculty of Electronics, Telecommunications and Informatics,
 * Multimedia Systems Department
 * and/or its affiliates. All rights reserved.
 */

#include <Wt/WContainerWidget>
#include <Wt/WMenu>

#include <string>

namespace SyNaT
{
  namespace MIR
  {
    namespace SP
    {
      using namespace std;

      class ControlsWidget : public Wt::WContainerWidget
      {
        public:
          ControlsWidget(bool hasSubMenu, const string cssClass = "", const bool forceCssClass = false);

          bool hasSubMenu() const { return has_sub_menu_; }

          virtual void populateSubMenu(Wt::WMenu *menu);

          virtual void clear();

          bool         wasRendered()
          {
            return this->m_was_rendered;
          }
        protected:
          bool m_was_rendered;
        private:
          bool has_sub_menu_;
      };
    }
  }
};

#endif // _MIR_SP_CONTROLSWIDGET_H_
