#ifndef _MIR_SP_EXPLORER_H_
#define _MIR_SP_EXPLORER_H_
/*
 * Copyright (c) 2011,
 * Technical University Of Gdansk,
 * Faculty of Electronics, Telecommunications and Informatics,
 * Multimedia Systems Department
 * and/or its affiliates. All rights reserved.
 */

#include <Wt/WMenu>
#include <Wt/WLineEdit>
#include <Wt/WTableView>
#include <Wt/Dbo/Dbo>
#include <Wt/Dbo/QueryModel>
#include <Wt/WWidget>

#include <string>

#include "ormclasses/mir_sp_nazartnazalbitp.h"
#include "models/mir_sp_models_nazartnazalbitp.h"
#include "utils/mir_trkeys.h"
#include "mir_firebird.h"
#include "mir_databasemodule.h"
#include "controls/mir_sp_controlswidget.h"
#include "mir_sp_synatpgapp.h"

namespace SyNaT
{
  namespace MIR
  {
    namespace SP
    {
      using namespace Wt;
      namespace dbo = Wt::Dbo;
      namespace synatDbo = SyNaT::MIR::SP::models;

      class ExplorerControls : public ControlsWidget
      {
        public:
          ExplorerControls(SyNaTPGApp *app, WMenu *mainmenu, DatabaseModule *dm, const string cssClass = "", const bool forceCssClass = "")
            : ControlsWidget(false, cssClass, forceCssClass), m_mainmenu(mainmenu), m_dm(dm), m_app(app), m_firebird(dm)
          {

            m_session.setConnection(m_firebird);

            m_session.mapClass<NazArtNazAlbItp>("MIR_NAZARTNAZALBITP");

            dbo::Transaction transaction(m_session);
            m_query =
                m_session.query< dbo::ptr<NazArtNazAlbItp> >
                  ("select u  from MIR_NAZARTNAZALBITP u ");
                // m_query.limit(this->m_rows * 100).offset(this->m_rows);
                // ROWS offset TO limit
          }

          virtual ~ExplorerControls()
          {
          }

          WWidget                *create_explorer_controls();
        protected:
           WMenu                 *m_mainmenu;
           DatabaseModule        *m_dm;
           SyNaTPGApp            *m_app;
           int                    m_rows;
           Firebird               m_firebird;
           dbo::Session           m_session;
           dbo::Query< dbo::ptr<NazArtNazAlbItp> > m_query;
      };
    }
  }
}

#endif /* _MIR_SP_EXPLORER_H_ */
