#ifndef _MIR_SP_LOGINCONTROLS_H_
#define _MIR_SP_LOGINCONTROLS_H_
/*
 * Copyright (c) 2011,
 * Technical University Of Gdansk,
 * Faculty of Electronics, Telecommunications and Informatics,
 * Multimedia Systems Department
 * and/or its affiliates. All rights reserved.
 */

#include <Wt/WWidget>
#include <Wt/WMenu>
#include <Wt/WLineEdit>
#include <Wt/WLabel>

#include "mir_databasemodule.h"
#include "controls/mir_sp_controlswidget.h"
#include "mir_sp_synatpgapp.h"

namespace SyNaT
{
  namespace MIR
  {
    namespace SP
    {
      using namespace Wt;

      class LoginControls : public ControlsWidget
      {
        public:
          void slt_login(void);

          void slt_register(void);

          void slt_cancelreg(void);

          void slt_createaccount(void);

          LoginControls(SyNaTPGApp *app, WMenu *mainmenu, DatabaseModule *dm, string internal_path_to_select, const bool createLoginScreen = true, const string styleClass = "", const bool forceClass = false);

          virtual ~LoginControls(void);

          WWidget *create_signin_page(void);

          //void populateSubMenu(Wt::WMenu *menu);

          WTableCell            *m_tcell;

        protected:
          WMenu                 *m_mainmenu;
          DatabaseModule        *m_dm;
          WLineEdit             *m_wleLogin;
          WLineEdit             *m_wlePassword;
          WLineEdit             *m_wlePasswordDup;
          WLineEdit             *m_wleEmail;
          WLineEdit             *m_wleName;
          WLineEdit             *m_wleSurname;

          WLabel                *m_wlblLogin;
          WLabel                *m_wlblLoginInvalidMsg;
          WLabel                *m_wlblPassword;
          WLabel                *m_wlblPasswordInvalidMsg;
          WLabel                *m_wlblPasswordDup;
          WLabel                *m_wlblPasswordDupInvalidMsg;
          WLabel                *m_wlblEmail;
          WLabel                *m_wlblEmailInvalidMsg;
          WLabel                *m_wlblName;
          WLabel                *m_wlblNameInvalidMsg;
          WLabel                *m_wlblSurname;
          WLabel                *m_wlblSurnameInvalidMsg;

          SyNaTPGApp            *m_app;

          string                 m_internal_path_to_select;
      //    Wt::WWidget *wText();
      //    Wt::WWidget *wTemplate();
      //    Wt::WWidget *wBreak();
      //    Wt::WWidget *wAnchor();
      //    Wt::WWidget *wImage();
      //    Wt::WWidget *wTable();
      //    Wt::WWidget *wTree();
      //    Wt::WWidget *wTreeTable();
      //    Wt::WWidget *wPanel();
      //    Wt::WWidget *wTabWidget();
      //    Wt::WWidget *wContainerWidget();
      //    Wt::WWidget *wMenu();
      //    Wt::WWidget *wGroupBox();
      //    Wt::WWidget *wStackedWidget();
      //    Wt::WWidget *wProgressBar();
      };
    }
  }
}

#endif // _MIR_SP_LOGINCONTROLS_H_
