﻿#ifndef _MIR_MR_MUSICROBOTAPP_H_
#define _MIR_MR_MUSICROBOTAPP_H_
/*
 * Copyright (c) 2011,
 * Technical University Of Gdansk,
 * Faculty of Electronics, Telecommunications and Informatics,
 * Multimedia Systems Department
 * and/or its affiliates. All rights reserved.
 */

#include <Wt/WApplication>
#include <Wt/WAnchor>
#include <Wt/WText>
#include <Wt/WProgressBar>
#include <Wt/WPushButton>
#include <Wt/WTimer>
#include <Wt/WTextArea>
#include <Wt/WAnchor>
#include <Wt/WMessageBox>
#include <Wt/WLabel>
#include <Wt/WLineEdit>

#include <boost/ptr_container/ptr_vector.hpp>
#include <boost/ptr_container/ptr_map.hpp>
#include <boost/thread/mutex.hpp>
#include <boost/thread.hpp>

#include <string>

#include "mir_databasemodule.h"

#include <ibpp.h>


namespace SyNaT
{
  namespace MIR
  {
    namespace SP
    {
      using namespace std;
      using namespace Wt;

      /**
       * A <code>SyNaTPGApp</code> is main application class which is instantiated
       * per user session.
       *
       * @author  Łukasz Matuszewski
       * @version $Id: mir_sp_synatpgapp.h 420 2011-09-13 12:21:40Z lmatusz $
       */
      class SyNaTPGApp : public WApplication
      {
//          friend void LoginPage::loginPage(void);
//          friend void LoginPage::m_slt_wpbLogin(void);
//          friend void MainPage::mainPage(void);
//          friend void SettingsPage::m_slt_wpbSave(void);
//          friend void SettingsPage::getMusicServers(void);
//          friend void SettingsPage::settingsPage(void);
//          friend void StatusPage::m_slt_wpbStart(void);
//          friend void StatusPage::statusPage(void);
//          friend void StatusPage::m_slt_wpbStop(void);
	      protected:

          void                                          destroyAllWidgets();
          void                                          removeAllWidgets();
          void                                          hideAllFields();

          void                                          changeStateOfMusicRobot(bool working);

          void                                          setFieldsToNull(bool nest);

					DatabaseModule                                m_dm;


          string                                        m_login;
          string                                        m_name;
          string                                        m_surname;
          string                                        m_hashpassword;
          string                                        m_serverName;
          string                                        m_databaseName;
          string                                        m_userName;
          string                                        m_userPassword;
          string                                        m_roleName;
          string                                        m_charSet;

          bool                                          m_signinRenedered;

          WTimer                                       *m_wtimer;
        public:
          typedef boost::ptr_map<string,string>         ptr_map_string_string;

          static ptr_map_string_string                  fillMimeTypes();

          void                                          activation(const string &path); /* wApp slot */

          /**
           * @returns how many users are logged (sessions started and not ended). NOTE:
           * the number is stored in shared between processes memory object.
           */
//          unsigned int                                  num_of_sessions();
//
//          /**
//           * Increases by 1 the number which indicates number of logged users (sessions
//           * started and not ended). NOTE:
//           * the number is stored in shared between processes memory object.
//           */
//          void                                          inc_num_of_sessions();
//
//          /**
//           * Decreases by 1 the number which indicates number of logged users (sessions
//           * started and not ended). NOTE:
//           * the number is stored in shared between processes memory object.
//           */
//          void                                          dec_num_of_sessions();


          void                                          m_slt_wtimerTimeout();
          
                                                        SyNaTPGApp(const WEnvironment& env);
          
          virtual                                      ~SyNaTPGApp();

          const static int                              mcs_osid;

          const static ptr_map_string_string            mcs_mime;  // file extension and mime type

          const static string                           mcs_root_elem;

          WText                                        *m_wtappmessage;
      }; // class SyNaTPGApp

    } // namespace SP
  } // namespace MIR
} // namespace SyNaT

#endif //_MIR_MR_MUSICROBOTAPP_H_
