#ifndef _MIR_SP_MODELS_NAZARTNAZALBITP_H_
#define _MIR_SP_MODELS_NAZARTNAZALBITP_H_
/*
 * Copyright (c) 2011,
 * Technical University Of Gdansk,
 * Faculty of Electronics, Telecommunications and Informatics,
 * Multimedia Systems Department
 * and/or its affiliates. All rights reserved.
 */
#include <Wt/WObject>
#include <Wt/Dbo/QueryModel>
#include <Wt/WModelIndex>
#include <Wt/Dbo/Dbo>

#include <boost/any.hpp>

#include "mir_databasemodule.h"
#include "ormclasses/mir_sp_nazartnazalbitp.h"

namespace SyNaT
{
  namespace MIR
  {
    namespace SP
    {
      namespace models
      {
        using namespace Wt;
        namespace dbo = Wt::Dbo;

        class NazArtNazAlbItpModel : public dbo::QueryModel<dbo::ptr<NazArtNazAlbItp> >
        {
          public:

            NazArtNazAlbItpModel(DatabaseModule *dm, WObject *parent = 0)
            : dbo::QueryModel<dbo::ptr<NazArtNazAlbItp> >(parent), m_dm(dm)
            {
            }

            virtual boost::any data(const WModelIndex& index, int role = DisplayRole)
              const;

          protected:
            DatabaseModule *m_dm;
        };
      }
    }
  }
}

#endif /* _MIR_SP_MODELS_NAZARTNAZALBITP_H_ */
