#ifndef _MIR_SP_NAZARTNAZALBITP_H_
#define _MIR_SP_NAZARTNAZALBITP_H_
/*
 * Copyright (c) 2011,
 * Technical University Of Gdansk,
 * Faculty of Electronics, Telecommunications and Informatics,
 * Multimedia Systems Department
 * and/or its affiliates. All rights reserved.
 */
#include <Wt/Dbo/Dbo>

#include <string>

namespace SyNaT
{
  namespace MIR
  {
    namespace SP
    {
      using namespace std;
      namespace dbo = Wt::Dbo;

      class NazArtNazAlbItp
      {
        public:
          long long m_naa_id;
          string m_nazwa_artysty;
          string m_nazwa_albumu;
          string m_gatunek;
          string m_tytul_utworu;
          string m_utid;
          string m_umid;
          template<class Action> void persist(Action& a)
          {
            dbo::field(a, m_naa_id, "NAA_ID");
            dbo::field(a, m_nazwa_artysty,     "ART_NAZWA_ARTYSTY");
            dbo::field(a, m_nazwa_albumu, "ALB_NAZWA_ALBUMU");
            dbo::field(a, m_gatunek, "GAT_GATUNEK");
            dbo::field(a, m_tytul_utworu, "UTW_TYTUL_UTWORU");
            dbo::field(a, m_utid, "UTID");
            dbo::field(a, m_umid, "UMID");
          }
      };
    }
  }
}

namespace Wt
{
  namespace Dbo
  {

    template<>
    struct dbo_traits<SyNaT::MIR::SP::NazArtNazAlbItp> : public dbo_default_traits
    {

      static const char *versionField()
      {
        return 0;
      }

      static const char *surrogateIdField()
      {
        return "UTW_ID";
      }

    };

  }
}

#endif // _MIR_SP_NAZARTNAZALBITP_H_
