#ifndef _MIR_SP_MUSICRESOURCE_H_
#define _MIR_SP_MUSICRESOURCE_H_
/*
 * Copyright (c) 2011,
 * Technical University Of Gdansk,
 * Faculty of Electronics, Telecommunications and Informatics,
 * Multimedia Systems Department
 * and/or its affiliates. All rights reserved.
 */
#include <Wt/WObject>
#include <Wt/WStreamResource>
#include <Wt/Http/Request>
#include <Wt/Http/Response>

#include <mir_databasemodule.h>

namespace SyNaT
{
  namespace MIR
  {
    namespace SP
    {
      using namespace Wt;

      class MusicResource : public WStreamResource
      {
        public:
          MusicResource(int iterations, DatabaseModule *dm, long long utwId, WObject *parent = 0);

          virtual ~MusicResource();

          virtual void handleRequest(const Wt::Http::Request& request,
                             Wt::Http::Response& response);
        protected:
          int                          m_iterations;
          DatabaseModule              *m_dm;
          string                       m_sciezka_do_pliku;
          string                       m_suggestedFileName;
          long long                    m_utwId;
          boost::uintmax_t             m_file_size;
          wstring                      m_generic_wstr;
      };
    }
  }
}

#endif // _MIR_SP_MUSICRESOURCE_H_
