#ifndef _MIR_CHARCLONERTOSTR_H_
#define _MIR_CHARCLONERTOSTR_H_
/*
 * Copyright (c) 2011,
 * Technical University Of Gdansk,
 * Faculty of Electronics, Telecommunications and Informatics,
 * Multimedia Systems Department
 * and/or its affiliates. All rights reserved.
 */

#include <sstream>
#include <string>

namespace SyNaT
{
  namespace MIR
  {
    using namespace std;
    /**
     * A <code>StringCloner</code> clones one string n-times producing returned
     * string.
     *
     * @author  Łukasz Matuszewski
     * @version $Id: mir_stringcloner.h 334 2011-08-18 09:12:33Z lmatusz $
     */
    class StringCloner
    {
      public:
        static string clone(const string &strToClone, int ntimes)
        {
          ostringstream oss;
          for(int i=0; i<ntimes; i++)
          {
            oss << strToClone;
          }
          return oss.str();
        }
    };
  }
}

#endif //_MIR_CHARCLONERTOSTR_H_
