#include <Wt/WApplication>
#include <Wt/WEnvironment>
#include <Wt/WLength>
#include <Wt/WTable>
#include <Wt/WTableCell>
#include <Wt/Dbo/Dbo>
#include <Wt/WItemDelegate>

#include <boost/lexical_cast.hpp>
#include <boost/ptr_container/ptr_vector.hpp>
#include <boost/any.hpp>

#include "utils/mir_internalpaths.h"
#include "utils/mir_trkeys.h"
#include "utils/mir_defines.h"
#include "utils/mir_stringutils.h"
#include "mir_databasetypes.h"
#include "mir_databasemodule.h"
#include "controls/mir_sp_controlswidget.h"
#include "mir_sp_synatpgapp.h"
#include "controls/mir_sp_explorercontrols.h"
#include "mir_firebird.h"
#include "ormclasses/mir_sp_nazartnazalbitp.h"
#include "models/mir_sp_models_nazartnazalbitp.h"
#include "widgets/mir_wcustomtableview.h"

#include <ibpp.h>

namespace SyNaT
{
  namespace MIR
  {
    namespace SP
    {

      using namespace std;
      using namespace Wt;
      namespace dbo = Wt::Dbo;
      using namespace SyNaT::MIR::SP::models;
      using namespace IBPP;

      WWidget *ExplorerControls::create_explorer_controls()
      {
        WTable *wtab = new WTable();
        wtab->setMargin(WLength::Auto, Left | Right);
        WTableCell *cell = wtab->elementAt(0,0);

        this->m_rows = 20;


        WCustomTableView *wtv = new WCustomTableView(cell);

        NazArtNazAlbItpModel *qmodel = new NazArtNazAlbItpModel(this->m_dm, this);
        qmodel->setQuery(m_query, true);
        qmodel->addColumn("ART_NAZWA_ARTYSTY", tr(MIR_TABLE_EXP_ARTIST_NAME));
        qmodel->addColumn("ALB_NAZWA_ALBUMU", tr(MIR_TABLE_EXP_ALBUM_NAME));
        qmodel->addColumn("GAT_GATUNEK", tr(MIR_TABLE_EXP_GENRE_NAME));
        qmodel->addColumn("UTW_TYTUL_UTWORU", tr(MIR_TABLE_EXP_TITLE_NAME));
        //qmodel->addColumn("UTID", tr(MIR_TABLE_EXP_UTID_NAME));
        //qmodel->addColumn("UMID", tr(MIR_TABLE_EXP_UMID_NAME));
        qmodel->addColumn("NAA_ID", tr(MIR_TABLE_EXP_DOWNLOAD_PARAMS_NAME));
        if(this->m_dm->isUser(MIR_MUSIC_FILE_OPERATOR))
          qmodel->addColumn("NAA_ID", tr(MIR_TABLE_EXP_DOWNLOAD_NAME));
        qmodel->setBatchSize(this->m_rows * 100);
        //transaction.commit();
        //ExplorerTableModel *model = new ExplorerTableModel(this->m_dm, this->m_rows * 3, 0, this);
        int cols = this->m_dm->isUser(MIR_MUSIC_FILE_OPERATOR) ? 6 : 5, colWidth = 100;
        wtv->setModel(qmodel);
        wtv->setSortingEnabled(0, true);
        wtv->setSortingEnabled(1, true);
        wtv->setSortingEnabled(2, true);
        wtv->setSortingEnabled(3, true);
        wtv->setSortingEnabled(4, false);
        if(this->m_dm->isUser(MIR_MUSIC_FILE_OPERATOR))
          wtv->setSortingEnabled(5, false);
        wtv->setRowHeight(22);
        for(int i = 0;i < cols;i++){
            wtv->setColumnWidth(i, colWidth);
        }
        //this->m_tv->pageChanged().connect(this, &ExplorerControls::slt_page_changed);
        //        wtc = wtab->elementAt(1,0);
        //        wtc->addWidget(this->m_tv->createPageNavigationBar());
        // Editing does not really work without Ajax, it would require an
        // additional button somewhere to confirm the edited value.
//        if(this->m_app->environment().ajax())
//        {
//            wtv->resize(cols * colWidth + cols * 7 + 20, 20 + this->m_rows * 22);
//            //this->m_tv->setEditTriggers(WAbstractItemView::SingleClicked);
//        }
//        else
//        {
            wtv->resize(cols * colWidth + cols * 7 + 20, 20 + this->m_rows * 22 + 20);
            //this->m_tv->setEditTriggers(WAbstractItemView::NoEditTrigger);
//        }
        wtv->sortByColumn(0, AscendingOrder);
        wtv->setAlternatingRowColors(true);
        wtv->setSelectable(true);
        this->m_was_rendered = true;
        /* this scrolls to exactly page one (leaving page zero on top hidden */
        /* and other pages hidden). */
//        wtv->scrollTo(wtv->model()->index(this->m_rows, 0), WTableView::PositionAtTop);
        return wtab;
      }

    }
  }
}
