#include "utils/mir_sha1.h"

#include <Wt/WApplication>
#include <Wt/WText>
#include <Wt/WProgressBar>
#include <Wt/WPushButton>
#include <Wt/WTimer>
#include <Wt/WTextArea>
#include <Wt/WAnchor>
#include <Wt/WMessageBox>
#include <Wt/WLabel>
#include <Wt/WContainerWidget>
#include <Wt/WLogger>
#include <Wt/WWidget>
#include <Wt/WHBoxLayout>
#include <Wt/WVBoxLayout>
#include <Wt/WEnvironment>

#include <sstream>

#include <Poco/Foundation.h>

#include <boost/foreach.hpp>
#include <boost/regex.hpp>
#include <boost/ptr_container/ptr_vector.hpp>
#include <boost/ptr_container/ptr_map.hpp>
#include <boost/thread/mutex.hpp>
#include <boost/filesystem.hpp>
#include <boost/interprocess/shared_memory_object.hpp>
#include <boost/interprocess/mapped_region.hpp>
#include <boost/interprocess/sync/named_mutex.hpp>
#include <boost/interprocess/sync/scoped_lock.hpp>
#include <boost/scoped_ptr.hpp>

#include <unicode/uclean.h>
#include <unicode/unistr.h>

#include "utils/mir_trkeys.h"
#include "utils/mir_defines.h"
#include "utils/mir_cssclasses.h"
#include "utils/mir_stringutils.h"
#include "mir_exceptions.h"
#include "mir_databasetypes.h"
#include "mir_databasemodule.h"
#include "utils/mir_utils.h"
#include "mir_sp_menuandcontents.h"
#include "resources/mir_sp_musicresource.h"
#include "mir_sp_synatpgapp.h"

#include <ibpp.h>

namespace SyNaT
{
  namespace MIR 
  {
    namespace SP
    {

      using namespace std;
      using namespace Wt;
      using namespace IBPP;
      using namespace boost::filesystem;
      using namespace boost::interprocess;

      /**
       * Przyjmuje że parametr path jest escape'owany z kodowania UTF-8. Path składa się ze ścieżki, parametrów i ich wartości np.
       * sciezka_escapeowana_ze_stringa_w_utf8/parametr_1_escapowany_ze_string_utf8/wartosci_parametru_1_escapowana_ze_stringa_w_utf8
       * /parametr_2_escapowany_ze_string_utf8/wartosci_parametru_2_escapowana_ze_stringa_w_utf8
       */
      void SyNaTPGApp::activation(const string &path)
      {
        //Utils::ptr_map_string_wxString ptr_map_params;
        //wxCSConv wxCharSetUTF8Conv(wxFONTENCODING_UTF8);
        //wxString wxpath = Utils::buildParameterMapFromPath(path, ptr_map_params, wxCharSetUTF8Conv);


        if (path.find("/activation") == 0)
        {
          string login = path.substr(12);
          login = login.substr(0, login.find("/"));
          string hashfromuri = path.substr(path.find_last_of("/")+1);
          Transaction tr = this->m_dm.createTransaction(amWrite, ilReadCommitted, lrWait);
          tr->Start();
          string sql = string("SELECT UZY_EMAIL FROM MIR_UZYTKOWNIK WHERE UZY_IDENTYFIKATOR = ") + DatabaseModule::toSql(login);
          Statement stmt = this->m_dm.createStatement(&tr, &sql);
          stmt->Execute();
          if (stmt->Fetch())
          {
            string email;
            stmt->Get(1, email);

            ostringstream oss;
            CSHA1 csha1;
            string strToCSHA1a1Update(string("flisaktoty ") + email);
            csha1.Update((const unsigned char *) strToCSHA1a1Update.c_str(), (unsigned int) strToCSHA1a1Update.length());
            csha1.Final();
            TCHAR hashparam[41];
            csha1.ReportHash(hashparam, CSHA1::REPORT_HEX_SHORT);
            char char_hashparam[41];
            for(int i = 0; i < 40; i++)
              char_hashparam[i] = (char) hashparam[i];
            char_hashparam[40] = 0;
            string hash(char_hashparam);
            if (!hashfromuri.compare(hash))
            {
              boost::ptr_vector<DBField> dbFields;
              dbFields.push_back(new INT64TDBField(MIR_ACTIVE, "UZY_PRAWA"));
              this->m_dm.updateTable(string(" UZY_IDENTYFIKATOR = ") + DatabaseModule::toSql(login), "UZY", "MIR_UZYTKOWNIK", dbFields, &tr);
              this->m_wtappmessage->setText(WString::tr(MIR_MSG_USERACTIVATED));
            }
          }
          tr->Commit();
        }
        else
        {
          if (this->m_wtappmessage)
            this->m_wtappmessage->setText(WString::tr(MIR_MSG_EMPTY));
        }
//        if (wxpath.CmpNoCase(wxString("start", wxCharSetUTF8Conv)) == 0)
//        {
//
//          this->m_mp.mainPage();
//
//        }
//        else if (wxpath.CmpNoCase(wxString("dwnlStatus", wxCharSetUTF8Conv)) == 0)
//        {
//
//          this->m_ssp.statusPage();
//
//        }
//        else if (wxpath.CmpNoCase(wxString("login", wxCharSetUTF8Conv)) == 0)
//        {
//
//          this->m_lp.loginPage();
//
//        }
//        else if (wxpath.CmpNoCase(wxString("logout", wxCharSetUTF8Conv)) == 0)
//        {
//          this->changeStateOfMusicRobot(false);
//          this->isMusicRobotWorking = false;
//          this->m_login.clear();
//          this->m_name.clear();
//          this->m_surname.clear();
//          this->m_hashpassword.clear();
//          this->setInternalPath("/login", true);
//        }
      }


      void SyNaTPGApp::m_slt_wtimerTimeout()
      {
          
//          for(size_t i=0; i < this->m_ssp.m_wpbr.size(); i++)
//          {
//            if (this->m_stopDownloading)
//            {
//              if (this->m_ssp.m_wpbr.at(i).value()!=0)
//                this->m_ssp.m_wpbr.at(i).setValue(0);
//              if (this->m_ssp.m_wpbStart && this->m_ssp.m_wpbStart->isDisabled())
//                this->m_ssp.m_wpbStart->enable();
//              if (this->m_ssp.m_wpbStop && this->m_ssp.m_wpbStop->isDisabled())
//                this->m_ssp.m_wpbStop->enable();
//              buttonsStartStopEnabled = true;
//
//              if (!downThreadsRecreate)
//                downThreadsRecreate = true;
//            }
//          }
//
//          for(size_t i=0; i < this->m_wxdt.size(); i++)
//          {
//            if (!this->m_stopDownloading)
//            {
//
//              if (i < this->m_ssp.m_wpbr.size())
//              {
//                boost::lock_guard<boost::mutex> lock(this->m_wxdt.at(i).m_downloadthread_m_progressPercent_mutex);
//                this->m_ssp.m_wpbr.at(i).setValue(this->m_wxdt.at(i).m_progressPercent);
//              }
//              {
//                boost::lock_guard<boost::mutex> lock(this->m_wxdt.at(i).m_downloadthread_m_wxuri_mutex);
//
//                if (this->m_wxdt.at(i).m_wxuri)
//                {
//                  if (i < this->m_ssp.m_wpbrTxt.size())
//                    this->m_ssp.m_wpbrTxt.at(i).setText(wx2wts(wxURI::Unescape(this->m_wxdt.at(i).m_wxuri->BuildURI())));
//                } else
//                {
//                  if (i < this->m_wxServer.size())
//                    this->m_ssp.m_wpbrTxt.at(i).setText(WString(this->m_wxServer.at(i).getMusicResource(), UTF8));
//                }
//              }
//            }
//            else
//            {
//              if (i < this->m_ssp.m_wpbr.size())
//                this->m_ssp.m_wpbr.at(i).setValue(0);
//              if ((i < this->m_ssp.m_wpbrTxt.size()) && (i < this->m_wxServer.size()))
//                this->m_ssp.m_wpbrTxt.at(i).setText(WString(this->m_wxServer.at(i).getMusicResource(), UTF8));
//            }
//          }
//        }
//
//        if(downThreadsRecreate || this->m_stopDownloading)
//        {
//          //wxCriticalSectionLocker wxcsl(SyNaTPGApp::ms_downloadthread_m_wxuri_crit_sect);
//
//          //DownloadThreadsRecreate();
//        }
//
//        if(this->m_stopDownloading && buttonsStartStopEnabled)
//        {
//          this->m_wtimer->stop();
//        }
      }

      void SyNaTPGApp::changeStateOfMusicRobot(bool working)
      {
        Transaction tr;
        try 
        {
          tr = this->m_dm.createTransaction(amWrite, ilReadCommitted, lrWait);
          boost::ptr_vector<DBField> fields;
          fields.push_back(new BoolDBField(working, "SMR_PRACUJE"));
          tr->Start();
          this->m_dm.updateTable(1, "SMR", "MIR_STAN_MUZYCZNEGO_ROBOTA", fields, &tr);
          tr->Commit();
        } catch(IBPP::Exception &e)
        {
          wApp->log("error") << e.Origin() << " " << e.what();
        }
      }

      SyNaTPGApp::SyNaTPGApp(const WEnvironment& env)
        : WApplication(env), m_signinRenedered(false)
      {
        UErrorCode ec;
        ec = U_ZERO_ERROR;
        u_init(&ec);
        if (U_FAILURE(ec))
          this->log("error") << "u_init(ec) failure";

        this->messageResourceBundle().use(SyNaTPGApp::mcs_osid == POCO_OS_WINDOWS_NT ?
            SyNaTPGApp::mcs_root_elem + MIR_FULLPATH_TO_MESS_RES_BUNDLE : MIR_FULLPATH_TO_MESS_RES_BUNDLE);

        this->setFieldsToNull(false);

        this->addMetaHeader("viewport", "width=700, height=1200");

        this->setCssTheme("polished");

        this->useStyleSheet("css/reset.css");
        //this->useStyleSheet("/css/wt/wt.css");
        //this->useStyleSheet("/css/wt/wt_ie.css", "lt IE 7");
        this->useStyleSheet("style/everywidget.css");
        this->useStyleSheet("style/dragdrop.css");
        this->useStyleSheet("style/combostyle.css");

        this->setTitle(WString::tr(MIR_SYNAT_BROWSER_TITLE));

        WHBoxLayout *layout = new WHBoxLayout(this->root());
        layout->setContentsMargins(0, 0, 0, 0);

        this->m_dm.connect(string("localhost"), "some_db", "SYSDBA", "some_SYSDBA_pass", "", "UTF8", "", "some_user", "some_user_pass", false);

        this->m_wtappmessage = new WText();
//        this->m_wtappmessage->setStyleClass(MIR_STRCAT3(MIR_CSS_HALFFONTSIZE," ",MIR_CSS_COLOR_RED));
        layout->addWidget(new MenuAndContents(this, &this->m_dm));

        this->m_wtimer = new WTimer((WObject *)((this->root())));
        this->m_wtimer->setInterval(5000); // co 5 sekund
        this->m_wtimer->timeout().connect(this, &SyNaTPGApp::m_slt_wtimerTimeout);
        this->activation(this->internalPath());
      }
//
//      unsigned int SyNaTPGApp::num_of_sessions()
//      {
//        unsigned int return_value;
//        boost::scoped_ptr<shared_memory_object> sp_shm_obj;
//        try
//        {
//          sp_shm_obj.reset(new shared_memory_object(open_only, MIR_NUM_OF_USERS_LOGGED_SMO, read_only));
//        }
//        catch(interprocess_exception &e)
//        {
//          return 0;
//        }
//        named_mutex f_lock(open_or_create, MIR_NUM_OF_USERS_LOGGED_NAMED_MUTEX);
//        {
//          scoped_lock<named_mutex> e_lock(f_lock);
//          if(e_lock.owns())
//          {
//            mapped_region region(*sp_shm_obj.get(), read_only);
//            const unsigned int *mem = static_cast<unsigned int*>(region.get_address());
//            return_value = *mem;
//          }
//        }
//        return return_value;
//      }
//
//      void SyNaTPGApp::inc_num_of_sessions()
//      {
//        boost::scoped_ptr<shared_memory_object> sp_shm_obj;
//        try
//        {
//          sp_shm_obj.reset(new shared_memory_object(create_only, MIR_NUM_OF_USERS_LOGGED_SMO, read_write, sizeof(unsigned int)));
//        }
//        catch(interprocess_exception &e)
//        {
//          sp_shm_obj.reset(new shared_memory_object(open_only, MIR_NUM_OF_USERS_LOGGED_SMO, read_write));
//        }
//        named_mutex f_lock(open_or_create, MIR_NUM_OF_USERS_LOGGED_NAMED_MUTEX);
//        {
//          scoped_lock<named_mutex> e_lock(f_lock);
//          if(e_lock.owns())
//          {
//            mapped_region region(*sp_shm_obj.get(), read_write);
//            unsigned int *mem = static_cast<unsigned int*>(region.get_address());
//            (*mem)++;
//          }
//        }
//      }
//
//      void SyNaTPGApp::dec_num_of_sessions()
//      {
//        boost::scoped_ptr<shared_memory_object> sp_shm_obj;
//        try
//        {
//          sp_shm_obj.reset(new shared_memory_object(create_only, MIR_NUM_OF_USERS_LOGGED_SMO, read_write, sizeof(unsigned int)));
//        }
//        catch(interprocess_exception &e)
//        {
//          sp_shm_obj.reset(new shared_memory_object(open_only, MIR_NUM_OF_USERS_LOGGED_SMO, read_write));
//        }
//        named_mutex f_lock(open_or_create, MIR_NUM_OF_USERS_LOGGED_NAMED_MUTEX);
//        {
//          scoped_lock<named_mutex> e_lock(f_lock);
//          if(e_lock.owns())
//          {
//            mapped_region region(*sp_shm_obj.get(), read_write);
//            unsigned int *mem = static_cast<unsigned int*>(region.get_address());
//            if ((*mem) > 0)
//              (*mem)--;
//          }
//        }
//      }

      SyNaTPGApp::~SyNaTPGApp()
      {
        this->destroyAllWidgets();

        delete this->m_wtappmessage;

        if (this->m_wtimer)
          this->m_wtimer->stop();

        this->m_dm.logout();

//        if (this->num_of_sessions() == 0)
//        {
//          shared_memory_object::remove(MIR_NUM_OF_USERS_LOGGED_SMO);
//        }

        u_cleanup();
      }

      void SyNaTPGApp::setFieldsToNull(bool nest)
      {
        this->m_wtimer = NULL;
      }

      void SyNaTPGApp::removeAllWidgets()
      {
        WContainerWidget *wcw = this->root();

        for(int i = 0, count = wcw->count(); i < count ; i++)
        {
          wcw->removeWidget(wcw->widget(0));
        }
      }
      
      void SyNaTPGApp::destroyAllWidgets()
      {
        this->root()->clear();
      }

      void SyNaTPGApp::hideAllFields()
      {
        WContainerWidget *wcw = this->root();
        for(int i = 0; i < wcw->count(); i++)
        {
          wcw->widget(i)->hide();
        }
      }


      SyNaTPGApp::ptr_map_string_string SyNaTPGApp::fillMimeTypes()
      {
        SyNaTPGApp::ptr_map_string_string mime;

        mime["AUDIO/BASIC"]= *new string("snd,au");
        mime["AUDIO/MID"] =*new string("mid,rmi");
        mime["AUDIO/MPEG"]= *new string("mp3,mp2,mp1");
        mime["AUDIO/MP4"]= *new string("mp4a");
        mime["AUDIO/OGG"]= *new string("oga,ogg,spx");
        mime["AUDIO/VORBIS"]= *new string("oga,ogg,spx");
        mime["AUDIO/X-MS-WMA"]= *new string("wma");
        mime["AUDIO/X-MS-WAX"]= *new string("wax");
        mime["AUDIO/X-MS-WMV"]= *new string("wmv");
        mime["AUDIO/X-MATROSKA"]= *new string("mka");
        mime["AUDIO/VND.RN-REALAUDIO"]= *new string("ra,ram");
        mime["AUDIO/X-PN-REALAUDIO"]= *new string("ra,ram");
        mime["AUDIO/VND.WAVE"]= *new string("wav");
        mime["AUDIO/WAV"]= *new string("wav");
        mime["AUDIO/WAVE"]= *new string("wav");
        mime["AUDIO/X-WAV"]= *new string("wav");

        mime["AUDIO/X-MPEGURL"] = *new string("m3u");
        mime["APPLICATION/VND.APPLE.MPEGURL"] = *new string("m3u8");

        mime["IMAGE/BMP"] = *new string("bmp");
        mime["IMAGE/CGM"] = *new string("cgm");
        mime["IMAGE/G3FAX"] = *new string("g3");
        mime["IMAGE/GIF"] = *new string("gif");
        mime["IMAGE/IEF"] = *new string("ief");
        mime["IMAGE/JP2"] = *new string("jp2");
        mime["IMAGE/JPEG"] = *new string("jpeg");
        mime["IMAGE/PNG"] = *new string("png");
        mime["IMAGE/PRS.BTIF"] = *new string("btif");
        mime["IMAGE/SVG+XML"] = *new string("svg,svgz");
        mime["IMAGE/TIFF"] = *new string("tiff,tif");
        mime["IMAGE/VND.ADOBE.PHOTOSHOP"] = *new string("psd");
        mime["IMAGE/VND.DJVU"] = *new string("djvu,djv");
        mime["IMAGE/VND.DWG"] = *new string("dwg");
        mime["IMAGE/VND.DXF"] = *new string("dxf");
        mime["IMAGE/VND.FASTBIDSHEET"] = *new string("fbs");
        mime["IMAGE/VND.FPX"] = *new string("fpx");
        mime["IMAGE/VND.FST"] = *new string("fst");
        mime["IMAGE/VND.FUJIXEROX.EDMICS-MMR"] = *new string("mmr");
        mime["IMAGE/VND.FUJIXEROX.EDMICS-RLC"] = *new string("rlc");
        mime["IMAGE/VND.MS-MODI"] = *new string("mdi");
        mime["IMAGE/VND.NET-FPX"] = *new string("npx");
        mime["IMAGE/VND.WAP.WBMP"] = *new string("wbmp");
        mime["IMAGE/VND.XIFF"] = *new string("xif");
        mime["IMAGE/X-CMU-RASTER"] = *new string("ras");
        mime["IMAGE/X-CMX"] = *new string("cmx");
        mime["IMAGE/X-FREEHAND"] = *new string("fh,fhc,fh4,fh5,fh7");
        mime["IMAGE/X-ICON"] = *new string("ico");
        mime["IMAGE/X-PCX"] = *new string("pcx");
        mime["IMAGE/X-PICT"] = *new string("pic,pct");
        mime["IMAGE/X-PORTABLE-ANYMAP"] = *new string("pnm");
        mime["IMAGE/X-PORTABLE-BITMAP"] = *new string("pbm");
        mime["IMAGE/X-PORTABLE-GRAYMAP"] = *new string("pgm");
        mime["IMAGE/X-PORTABLE-PIXMAP"] = *new string("ppm");
        mime["IMAGE/X-RGB"] = *new string("rgb");
        mime["IMAGE/X-XBITMAP"] = *new string("xbm");
        mime["IMAGE/X-XPIXMAP"] = *new string("xpm");
        mime["IMAGE/X-XWINDOWDUMP"] = *new string("xwd");

        mime["TEXT/CSS"] = *new string("css");

        mime["TEXT/JAVASCRIPT"] = *new string("js");
        mime["APPLICATION/X-JAVASCRIPT"] = *new string("js");
        mime["APPLICATION/JAVASCRIPT"] = *new string("js");
        mime["TEXT/ECMASCRIPT"] = *new string("js");
        mime["APPLICATION/ECMASCRIPT"] = *new string("js");
        mime["TEXT/JSCRIPT"] = *new string("js");
        mime["TEXT/VBSCRIPT"] = *new string("js");

        mime["TEXT/HTML"]= *new string("html,htm,*");
        mime["TEXT/XML"]= *new string("xml,xhtm,xhtml,*");
        mime["APPLICATION/XHTML+XML"]= *new string("xml,xhtm,xhtml");
        mime["APPLICATION/XML"]= *new string("xml,xhtm,xhtml");
        mime["TEXT/PLAIN"]= *new string("txt,*");

        return mime;
      }

      const int SyNaTPGApp::mcs_osid = POCO_OS;

      const SyNaTPGApp::ptr_map_string_string SyNaTPGApp::mcs_mime = SyNaTPGApp::fillMimeTypes();


      const string SyNaTPGApp::mcs_root_elem = Utils::icusToUTF8(
          (*current_path().begin()).native().c_str());
    } // namespace SP
  } // namespace MIR
} // namespace SyNaT
