#include <Wt/WApplication>
#include <Wt/WLogger>
#include <Wt/WAnchor>
#include <Wt/Dbo/Dbo>
#include <Wt/Dbo/QueryModel>
#include <Wt/WModelIndex>
#include <Wt/WLink>

#include <string>

#include <boost/lexical_cast.hpp>
#include <boost/any.hpp>

#include "utils/mir_trkeys.h"
#include "resources/mir_sp_musicresource.h"
#include "resources/mir_sp_paramsresource.h"
#include "ormclasses/mir_sp_nazartnazalbitp.h"
#include "models/mir_sp_models_nazartnazalbitp.h"


namespace SyNaT
{
  namespace MIR
  {
    namespace SP
    {
      namespace models
      {
        using namespace Wt;
        namespace dbo = Wt::Dbo;

        boost::any NazArtNazAlbItpModel::data(const WModelIndex& index, int role)
          const
        {
          if ((role == DisplayRole || role == EditRole))
          {
            if (index.column() < 4)
              return this->dbo::QueryModel<dbo::ptr<NazArtNazAlbItp> >::data(index, role);
            else if (index.column() == 4)
              return WString::tr(MIR_TABLE_EXP_DOWNLOAD_PARAMS);
            else if (index.column() == 5)
              return WString::tr(MIR_TABLE_EXP_DOWNLOAD);            
          }
          else if (role == LinkRole)
          {
           if (index.column() == 4)
           {
              return WLink(new ParamsResource(this->m_dm, this->resultRow(index.row())->m_naa_id));
           }
           else if (index.column() == 5)
             return WLink(new MusicResource(1, this->m_dm, this->resultRow(index.row())->m_naa_id));
          }
          return boost::any();
        }
      }

    }
  }
}
