#include <boost/lexical_cast.hpp>

#include <widgets/mir_wcustomtableviewpushbutton.h>

namespace SyNaT
{
  namespace MIR
  {
    using namespace Wt;

    void WCustomTableViewPushButton::slt_first_page_clicked()
    {
      if (this->m_wctv->pageCount() > 0)
      {
        if (this->m_wctv->m_current_page != 0)
          this->m_wctv
            ->scrollTo(
                this->m_wctv->model()->index(0, 0), WTableView::PositionAtTop);
        this->m_wctv->m_current_page = 0;
        this->m_wctv->m_first_page_in_nav_bar = 0;
        this->m_wctv->m_last_page_in_nav_bar = this->m_wctv->m_num_of_pages_in_nav_bar - 1;
        this->m_wctv->m_nav_bar_needs_update = true;
      }
      this->m_wctv->update_page_nav_bar();
    }

    void WCustomTableViewPushButton::slt_prev_page_clicked()
    {
      if (this->m_wctv->pageCount() > 0)
      {
        if (this->m_wctv->m_current_page > 0)
        {
          this->m_wctv
            ->scrollTo(
                this->m_wctv->model()
                  ->index((--this->m_wctv->m_current_page) * (this->m_wctv->pageSize() + 2), 0), WTableView::PositionAtTop);
          if (this->m_wctv->m_first_page_in_nav_bar > this->m_wctv->m_current_page)
          {
            this->m_wctv->m_first_page_in_nav_bar--;
            this->m_wctv->m_last_page_in_nav_bar--;
            this->m_wctv->m_nav_bar_needs_update = true;
          }
        }

      }
      this->m_wctv->update_page_nav_bar();
    }

    void WCustomTableViewPushButton::slt_next_page_clicked()
    {
      if (this->m_wctv->pageCount() > 0)
      {
        if (this->m_wctv->m_current_page < (this->m_wctv->model()->rowCount() / (this->m_wctv->pageSize() + 2)))
        {
          this->m_wctv
            ->scrollTo(
                this->m_wctv->model()
                  ->index((++this->m_wctv->m_current_page) * (this->m_wctv->pageSize() + 2), 0), WTableView::PositionAtTop);
          if (this->m_wctv->m_last_page_in_nav_bar < this->m_wctv->m_current_page)
          {
            this->m_wctv->m_first_page_in_nav_bar++;
            this->m_wctv->m_last_page_in_nav_bar++;
            this->m_wctv->m_nav_bar_needs_update = true;
          }

        }
      }
      this->m_wctv->update_page_nav_bar();
    }

    void WCustomTableViewPushButton::slt_last_page_clicked()
    {
      if (this->m_wctv->pageCount() > 0)
      {
        if (this->m_wctv->m_current_page != (this->m_wctv->model()->rowCount() / (this->m_wctv->pageSize() + 2)))
        {
          this->m_wctv
            ->scrollTo(
                this->m_wctv->model()
                  ->index(this->m_wctv->model()->rowCount() - (this->m_wctv->pageSize() + 2), 0), WTableView::PositionAtTop);
          this->m_wctv->m_current_page = this->m_wctv->model()->rowCount() / (this->m_wctv->pageSize() + 2);
          this->m_wctv->m_first_page_in_nav_bar = this->m_wctv->m_current_page - this->m_wctv->m_num_of_pages_in_nav_bar + 1;
          this->m_wctv->m_last_page_in_nav_bar = this->m_wctv->m_current_page;
          this->m_wctv->m_nav_bar_needs_update = true;
        }

      }
      this->m_wctv->update_page_nav_bar();
    }

    void WCustomTableViewPushButton::slt_page_clicked()
    {
      if (this->m_wctv->pageCount() > 0)
      {
        int page_clicked = boost::lexical_cast<int>(this->text().toUTF8());
        page_clicked--;
        if (page_clicked <= this->m_wctv->pageCount())
          this->m_wctv
            ->scrollTo(
                this->m_wctv->model()
                  ->index(page_clicked * (this->m_wctv->pageSize() + 2), 0), WTableView::PositionAtTop);
        this->m_wctv->m_current_page = page_clicked;
        this->m_wctv->m_nav_bar_needs_update = true;
      }
      this->m_wctv->update_page_nav_bar();
    }

    void WCustomTableViewPushButton::slt_next_pages_clicked()
    {
      if (this->m_wctv->m_first_page_in_nav_bar < ((this->m_wctv->model()->rowCount() / (this->m_wctv->pageSize() + 2)) - this->m_wctv->m_num_of_pages_in_nav_bar + 1))
      {
        this->m_wctv->m_first_page_in_nav_bar += this->m_wctv->m_num_of_pages_in_nav_bar;
        this->m_wctv->m_last_page_in_nav_bar += this->m_wctv->m_num_of_pages_in_nav_bar;
        this->m_wctv->m_nav_bar_needs_update = true;
        this->m_wctv->update_page_nav_bar();
      }
    }

    void WCustomTableViewPushButton::slt_prev_pages_clicked()
    {
      if (this->m_wctv->m_first_page_in_nav_bar > this->m_wctv->m_num_of_pages_in_nav_bar - 1)
      {
        this->m_wctv->m_first_page_in_nav_bar -= this->m_wctv->m_num_of_pages_in_nav_bar;
        this->m_wctv->m_last_page_in_nav_bar -= this->m_wctv->m_num_of_pages_in_nav_bar;
        this->m_wctv->m_nav_bar_needs_update = true;
        this->m_wctv->update_page_nav_bar();
      }
    }


  }
}
